unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, CRVData, RVItem, RVTable, StdCtrls, RVStyle, RVScroll,
  RichView, RVUni;

type
  TForm1 = class(TForm)
    RichView1: TRichView;
    RVStyle1: TRVStyle;
    Button1: TButton;
    CheckBox1: TCheckBox;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
  private
    { Private declarations }
    procedure DoBreak(RVData: TCustomRVData);
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.DoBreak(RVData: TCustomRVData);
var i,j,r,c, StyleNo: Integer;
    table: TRVTableItemInfo;
    s,s2: String;
    item: TRVTextItemInfo;
begin
  for i := RVData.ItemCount-1 downto 0 do begin
    StyleNo := RVData.GetItemStyle(i);
    if StyleNo=rvsTable then begin
      // table
      table := TRVTableItemInfo(RVData.GetItem(i));
      for r := 0 to table.Rows.Count-1 do
        for c := 0 to table.Rows[r].Count-1 do
          if table.Cells[r,c]<>nil then
            DoBreak(table.Cells[r,c].GetRVData);
    end
    else if StyleNo>=0 then begin
      // text
      s := RVData.GetItemTextA(i);
      for j := Length(s) downto 2 do
        if s[j]='(' then begin
          s2 := Copy(s, j, Length(s));
          // changing text of the i-th item to the text before '('
          s := Copy(s, 1, j-1);
          RVData.SetItemTextA(i, s);
          // inserting a new text item with text starting from '('
          item := RichViewTextItemClass.Create(RVData);
          item.StyleNo := StyleNo;
          item.ParaNo := RVData.GetItemPara(i);
          item.BR := True; // <BR>
          if rvioUnicode in RVData.GetItem(i).ItemOptions then begin
            item.ItemOptions := item.ItemOptions+[rvioUnicode];
            s2 := RVU_AnsiToUnicode(RVData.GetStyleCodePage(StyleNo), s2);
          end;
          item.Inserting(RVData, s2, False);
          RVData.Items.InsertObject(i+1, s2, item);
          item.Inserted(RVData, i+1);
        end;
      if (s<>'') and (s[1]='(') and not RVData.IsFromNewLine(i) and
         (RVData.GetItemStyle(i-1)<>rvsListMarker) then
        // moving the whole item to the next line
        RVData.GetItem(i).BR := True;
    end;
  end;
end;                               

procedure TForm1.FormCreate(Sender: TObject);
begin
  RichView1.AddNL('List:(Option1(Options2(Option3', 0, 0);
  RichView1.Add('(option4(Options5(Option6', 3);
  RichView1.Format;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  DoBreak(RichView1.RVData);
  RichView1.Format;
end;

procedure TForm1.CheckBox1Click(Sender: TObject);
begin
  if CheckBox1.Checked then
    RichView1.Options := RichView1.Options+[rvoShowSpecialCharacters]
  else
    RichView1.Options := RichView1.Options-[rvoShowSpecialCharacters];
  RichView1.Reformat;
end;

end.
